﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using CommandLine;
using System.ComponentModel.DataAnnotations;

namespace files_to_shm
{
	class Args
	{
		[RegularExpression("^[\\x20-\\x7E]*$", ErrorMessage = "BaseDir must only contain ASCII characters.")]
		// TODO: Add a default value for BaseDir (app dir) //DONE?
		[Option('b', "basedir", Required = false, Default = "", HelpText = "Folder where the images are located.")]
		public string BaseDir { get; set; }

		[Range(1, int.MaxValue, ErrorMessage = "MaxImages must be greater than or equal to 1.")]
		[Option('m', "max", Required = true, HelpText = "Maximum number of images.")]
		public int MaxImages { get; set; }

		[Range(1, int.MaxValue, ErrorMessage = "Delay must be greater than or equal to 1.")]
		[Option('d', "delay", Required = false, Default = 250, HelpText = "Delay between images, in ms.")]
		public int Delay { get; set; }

        [Range(0, int.MaxValue, ErrorMessage = "Offset must be a positive number")]
        [Option("off0", Required = false, Default = 0, HelpText = "Frame offset for dev0. This number wiill be added to the frame index at every transaction.")]
        public int off0 { get; set; }

        [Range(0, int.MaxValue, ErrorMessage = "Offset must be a positive number")]
        [Option("off1", Required = false, Default = 0, HelpText = "Frame offset for dev1. This number wiill be added to the frame index at every transaction.")]
        public int off1 { get; set; }

        [Range(0, int.MaxValue, ErrorMessage = "Offset must be a positive number")]
        [Option("off2", Required = false, Default = 0, HelpText = "Frame offset for dev2. This number wiill be added to the frame index at every transaction.")]
        public int off2 { get; set; }

        [Range(0, int.MaxValue, ErrorMessage = "Offset must be a positive number")]
        [Option("off3", Required = false, Default = 0, HelpText = "Frame offset for dev3. This number wiill be added to the frame index at every transaction.")]
        public int off3 { get; set; }

        [Range(0, int.MaxValue, ErrorMessage = "Offset must be a positive number")]
        [Option("off4", Required = false, Default = 0, HelpText = "Frame offset for dev4. This number wiill be added to the frame index at every transaction.")]
        public int off4 { get; set; }

        [Range(0, int.MaxValue, ErrorMessage = "Offset must be a positive number")]
        [Option("off5", Required = false, Default = 0, HelpText = "Frame offset for dev5. This number wiill be added to the frame index at every transaction.")]
        public int off5 { get; set; }

        [RegularExpression("^[\\x20-\\x7E]*$", ErrorMessage = "Cam0 must only contain ASCII characters.")]
		[Option("cam0", Required = true, HelpText = "The prefix of Cam0.")]
		public string Cam0 { get; set; }

		[RegularExpression("^[\\x20-\\x7E]*$", ErrorMessage = "Cam1 must only contain ASCII characters.")]
		[Option("cam1", Required = false, Default = "not defined", HelpText = "The prefix of Cam1.")]
		public string Cam1 { get; set; }

		[RegularExpression("^[\\x20-\\x7E]*$", ErrorMessage = "Cam2 must only contain ASCII characters.")]
		[Option("cam2", Required = false, Default = "not defined", HelpText = "The prefix of Cam2.")]
		public string Cam2 { get; set; }

		[RegularExpression("^[\\x20-\\x7E]*$", ErrorMessage = "Cam3 must only contain ASCII characters.")]
		[Option("cam3", Required = false, Default = "not defined", HelpText = "The prefix of Cam3.")]
		public string Cam3 { get; set; }

		[RegularExpression("^[\\x20-\\x7E]*$", ErrorMessage = "Cam4 must only contain ASCII characters.")]
		[Option("cam4", Required = false, Default = "not defined", HelpText = "The prefix of Cam4.")]
		public string Cam4 { get; set; }

		[RegularExpression("^[\\x20-\\x7E]*$", ErrorMessage = "Cam5 must only contain ASCII characters.")]
		[Option("cam5", Required = false, Default = "not defined", HelpText = "The prefix of Cam5.")]
		public string Cam5 { get; set; }

        [RegularExpression("^[\\x20-\\x7E]*$", ErrorMessage = "LiDAR basepath and name must only contain ASCII characters.")]
        [Option('l', "lidar", Required = false, Default = "not defined", HelpText = "The full path AND basename(!!) for the lidar xyz files, so full path and name, but without the index and extension")]
        public string lidar { get; set; }

        [RegularExpression("^[\\x20-\\x7E]*$", ErrorMessage = "CSV path and name must only contain ASCII characters.")]
        [Option('c', "csv", Required = false, Default = "not defined", HelpText = "The full path for the .csv file containing the metadata. (including filename and extension)")]
        public string csv { get; set; }

        [RegularExpression("^[\\x20-\\x7E]*$", ErrorMessage = "not valid extension")]
        [Option('e', "ext", Required = false, Default = "bmp", HelpText = "the fileformat/extension of the input images (jpg/bmp implemented)")]
        public string ext { get; set; }

        [Option('v', "verbose", Required = false, Default = false, HelpText = "If verbose is set, every transaction is printed to console")]
		public bool Verbose { get; set; }
	}
}
