﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;
using System.ComponentModel.DataAnnotations;
using System.Globalization;
using System.Runtime.InteropServices;
using static files_to_shm.Program;
using System.Text.RegularExpressions;

namespace files_to_shm
{
    public struct metaLine
    {
        public int frameID;
        public float lat;
        public float lon;
        public float alt;
        public float vel;
        public float Ax;
        public float Ay;
        public float Az;
        public float Mx;
        public float My;
        public float Mz;
    }
    class CsvHandler
    {
        public metaLine[] metadata = new metaLine[runParams.maxImages+1];

        public void loadcsv(string csvpath)
        {
            if (File.Exists(csvpath))
            {
                StreamReader reader = new StreamReader(csvpath);
                reader.ReadLine(); //skip first line
                int frameID = 0;
                while (!reader.EndOfStream && frameID+1<metadata.Length)
                {
                    string cLineIn = reader.ReadLine();
                    string[] cLineSplit = cLineIn.Split(';');
                    frameID = int.Parse(cLineSplit[0]);

                    metadata[frameID].frameID = int.Parse(cLineSplit[0]);
                    metadata[frameID].lat = float.Parse(cLineSplit[1], culture);
                    metadata[frameID].lon = float.Parse(cLineSplit[2], culture);
                    metadata[frameID].alt = float.Parse(cLineSplit[3], culture);
                    metadata[frameID].vel = float.Parse(cLineSplit[4], culture);
                    metadata[frameID].Ax = float.Parse(cLineSplit[5], culture);
                    metadata[frameID].Ay = float.Parse(cLineSplit[6], culture);
                    metadata[frameID].Az = float.Parse(cLineSplit[7], culture);
                    metadata[frameID].Mx = float.Parse(cLineSplit[8], culture);
                    metadata[frameID].My = float.Parse(cLineSplit[9], culture);
                    metadata[frameID].Mz = float.Parse(cLineSplit[10], culture);
                }
                reader.Close();
            }

            else
            {
                Console.WriteLine("metadata file does not exist");
            }
         }
        public metaLine getMetaData(int id)
        {
            metaLine current=new metaLine();
            current = metadata[id];
            return current;
        }
    }
}
